-- This is the main Lua script file.
-- This file contains the main game loop as well as the main game event handler and state machine update

RunGame = true

-- Somet game state defines:

STATE_SPLASH		=	1
STATE_MENU		=	2
STATE_GAME		=	3
STATE_PAUSE		=	4
CURRENT_STATE		=	1 -- Start in the splash

function init()
	if testSettings() then
		loadSettings()
	end

	initGame() -- Sets up the Game
	initMenu()
	initSplash()
	CURRENT_STATE = STATE_SPLASH
	RunGame = true
end

function run()
	repeat

	if CURRENT_STATE == STATE_SPLASH then
		splashState()
	elseif CURRENT_STATE == STATE_MENU then
		menuState()
	elseif CURRENT_STATE == STATE_GAME then
		gameState()
	elseif CURRENT_STATE == STATE_PAUSE then
		pauseState()
	end

	until not RunGame
end

function kill()
	RunGame = false
	saveSettings()
	endGame()
end

function splashState()
		updateInput(0)
		updateSplash()
		renderSplash()
end

function menuState()
		updateInput(0)		-- Update the Direct Input wrapper
		hardcodedInput()	-- Calls the C++ func to check for
					-- Input that doesn't change.
		updateMenu()
		renderMenu()
		checkMessagePump()
end

function gameState()
		input()			-- handles input
		updateGame()		-- simulation
		renderGame()		-- render
		checkMessagePump()	-- Checks the windows message queue.
end

function pauseState()
		updateInput(0)		-- Update DI wrapper
		updatePause()		-- Check for return to game/menu input.
		renderPause()		-- render
		checkMessagePump()	-- Checks the windows message queue.
end