// Combines the bloom'd 2d pass with the 3d pass.

uniform sampler2D pass3dtx;
uniform sampler2D pass2dtx;
uniform sampler2D passBloomtx;

void main()
{
	// The 3D pass
	vec4 p3d = vec4(texture2D(pass3dtx,gl_TexCoord[0].st));
	// The 2D pass
	vec4 p2d = vec4(texture2D(pass2dtx,gl_TexCoord[0].st));
	// The bloomed 2D pass
	vec4 pBloom = vec4(texture2D(passBloomtx,gl_TexCoord[0].st));

	// If there was something drawn in the non bloom pass, don't add the color.
	if (p2d.r > 0.0 || p2d.g > 0.0 || p2d.b > 0.0)
		p3d = vec4(0.0, 0.0, 0.0, 0.0);

	gl_FragColor = p3d + pBloom ;
}